/****************************************************************************
 File name:  CS460_Fork.c
 Author:     $Author$
 Date:       Feb 21, 2012
 Class:      
 Assignment: 
 Purpose:    
 RevisionID:  $Id$
 ****************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#define MAX 20

#define PRIME 1
#define NOT_PRIME 0

#define READ 0
#define WRITE 1


/****************************************************************************
Function: 		isPrime

Description: 	Determine if an integer is prime

Parameters: 	value - the integer to test for primeness

Returned: 		int - 0 if not prime, 1 if prime
****************************************************************************/
int isPrime(int value)
{
	int prime = PRIME;
	int i;


	if(0 == value % 2 )
	{
		prime = NOT_PRIME;
	}
	else
	{
		for(i=3; i< (value/3) +1 && prime; i++)
		{
			if(	0 == value % i )
			{
				prime = NOT_PRIME;
			}
		}
	}

	return prime;
}




/****************************************************************************
Function: 		main

Description: 	Allocate a pipe, fork the process.  The parent will send a series
							of integers through the pipe to the child.  The child will test
							for primeness and print message to the screen stating if the
							given number is prime.

Parameters: 	none

Returned: 		int - 0 if success, -1 if failure
****************************************************************************/

int main()
{

	int thePipe[2];

	pid_t pid;

	// build a pipe


	// fork

	// exit if fork fails


	// PARENT
	// send the odd integers 3 to MAX to the child


	// CHILD
	// close the write PIPE, the child only READS
	// get the child's process id

	// read an integer from the PIPE.
	// IF the read returns 0 or -1 an error occurred or the
	// pipe was closed on the parent side. The child is done!
	//
	// determine if the integer is prime
	// print a message to the screen that includes
	// child process id, the integer, the integer's prime status (true/false)


	// PARENT & CHILD
	// close remaining pipes

	// PARENT wait on child

	return 0;
}

