/****************************************************************************
 File name:  CS460_ForkMulti.c
 Author:     $Author$
 Date:       Feb 21, 2012
 Class:      
 Assignment: 
 Purpose:    
 RevisionID:  $Id$
 ****************************************************************************/
#include <stdio.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/wait.h>

#define MAX 200
#define CHILDREN 2

#define PRIME 1
#define NOT_PRIME 0

#define READ 0
#define WRITE 1

/****************************************************************************
Function: 		isPrime

Description: 	Determine if an integer is prime

Parameters: 	value - the integer to test for primeness

Returned: 		int - 0 if not prime, 1 if prime
****************************************************************************/
int isPrime(int value)
{
	int prime = 1;
	int i;


	if(0 == value % 2 )
	{
		prime = 0;
	}
	else
	{
		for(i=3; i< (value/3) +1 && prime; i++)
		{
			if(	0 == value % i )
			{
				prime = 0;
			}
		}
	}

	return prime;
}

/****************************************************************************
Function: 		main

Description: 	Allocate  pipes, fork the process twice.  The parent will send a
							unique series of integers to each child to test for primeness.
							The children will print a message to the screen denoting the
							primeness of each integer.

							The parent will wait until both children are terminated to
							terminate itself.

Parameters: 	none

Returned: 		int - 0 if success, -1 if failure
****************************************************************************/

int main()
{

	int thePipe[CHILDREN][2];
	pid_t pid[CHILDREN];

	// FOR EACH CHILD

		// build a pipe

		// fork

		// exit if fork fails


		// CHILD
		// close the write PIPE, the child only READS
		// get the child's process id

		// read an integer from the PIPE.
		// IF the read returns 0 or -1 an error occurred or the
		// pipe was closed on the parent side. The child is done!
		//
		// determine if the integer is prime
		// print a message to the screen that includes
		// child process id, the integer, the integer's prime status (true/false)


	// PARENT
	// send half of the odd integers 3 to MAX to each child

	// PARENT & CHILDREN
	// close remaining pipes

	// PARENT wait on each child
	return 0;
}

